# -*- coding: utf-8 -*-
from setuphelpers import *
import winshell
import glob
import time

def install():
    # Declaring local variables
    package_version = control.get_software_version()
    bin_name = glob.glob("*.exe")[0]

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(name=r"Avidemux"):
        if Version(to_uninstall["version"], 3) < Version(package_version, 3) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(control.impacted_process.split(","))
            cmd = to_uninstall["uninstall_string"]
            run(f'"{cmd}" /S')
            wait_uninstallkey_absent(to_uninstall["key"])

    if need_install_avidemux(control):
        favi=glob.glob(makepath( programfiles64(),'Avidemux * VC++ 64bits','Uninstall Avidemux VC++ 64bits.exe'))
        if favi:
            run(r'"%s" --script "%s\avidemux.qs" ' % (favi[0],basedir))
            time.sleep(120)

    for u in glob.glob(makepath(winshell.programs(1),'Avidemux * VC++ 64bits')):
        remove_tree(u)

    # Installing the software
    print("Installing: %s" % bin_name)

    if need_install_avidemux(control):
        run(r'"%s" --script "%s\avidemux.qs"' % (bin_name,basedir),accept_returncodes=[0, 1223])
        time.sleep(120)
    if need_install_avidemux(control):
        error('error %s not found or not in good version' % makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'avidemux.exe'))
    filecopyto(r'avidemux.qs',makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'avidemux.qs'))
    if isdir(makepath(winshell.programs(0),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)))):
        copytree2(makepath(winshell.programs(0),'Avidemux %s VC++ 64bits' % str(Version( control.version,2))),makepath(winshell.programs(1),'Avidemux %s VC++ 64bits' % str(Version( control.version,2))))

def audit():
    bin_avidemux = makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'avidemux.exe')
    if not isfile(bin_avidemux):
        return "ERROR"

    if Version(get_file_properties(bin_avidemux)['ProductVersion'],3) != Version( control.get_software_version(),3):
        return "ERROR"

    return "OK"

def uninstall():
    bin_uninstall = makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'Uninstall Avidemux VC++ 64bits.exe')
    run(r'"%s" --script "%s"' % (bin_uninstall,makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'avidemux.qs')))
    if isdir(makepath(winshell.programs(1),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)))):
        remove_tree(makepath(winshell.programs(1),'Avidemux %s VC++ 64bits' % str(Version( control.version,2))))

def need_install_avidemux(control=None):
    bin_avidemux = makepath( programfiles64(),'Avidemux %s VC++ 64bits' % str(Version( control.version,2)),'avidemux.exe')
    if isfile(bin_avidemux):
        if Version(get_file_properties(bin_avidemux)['ProductVersion'],3) < Version( control.get_software_version(),3):
            return True
        else:
            return False
    else:
        return True